Adding multiple times the same related issue relation is possible
2011-11-29 09:30 - Etienne Massip

Status: Closed Start date: 2011-11-29
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 1.4.0

Resolution: Fixed Affected version: 1.2.2
Description

See #4911, | added relation to #7445 twice in a row with Firefox (unstable) just pressing Enter key, maybe longer than normal.

Associated revisions

Revision 8041 - 2011-12-03 13:12 - Etienne Massip

Enforced unicity of relations between 2 issues with a database index (#9685).

History

#1 - 2011-12-01 19:21 - Etienne Massip

- Subject changed from Adding multiple times the same related issue is possible to Adding multiple times the same related issue relation is possible

As explained in RoR documentation (both 2.3.x and 3.x, this excerpt is from 3.x'):

Concurrency and integrity

Using this validation method in conjunction with ActiveRecord::Base#save does not guarantee the absence of dup
licate record insertions, because uniqueness checks on the application level are inherently prone to race cond
itions.

()

This could even happen if you use transactions with the ‘serializable’ isolation level. The best way to work a
round this problem is to add a unique index to the database table using (...)#add_index.

fooo)

The bundled ActiveRecord::ConnectionAdapters distinguish unique index constraint errors from other types of da
tabase errors by throwing an ActiveRecord::RecordNotUnique exception. For other adapters you will have to pars
e the (database-specific) exception message to detect such a case.

A simple migration creating an unique index on to and from issue_relation columns should do the job.

#2 - 2011-12-01 20:54 - Etienne Massip

- File add_unique_index_in_issue_relations.patch added

Migration patch attached.

#3 - 2011-12-01 20:54 - Etienne Massip

- Target version changed from Candidate for next minor release to Candidate for next major release

Ok, since there is a migration, moving to major.

#4 - 2011-12-02 23:29 - Jean-Philippe Lang

- Target version changed from Candidate for next major release to 1.4.0

#5 - 2011-12-03 13:14 - Etienne Massip
- Status changed from Confirmed to Resolved

- Resolution set to Fixed

Migration committed with r8041.
https://www.redmine.org/issues/4911
https://www.redmine.org/issues/7445
http://api.rubyonrails.org/classes/ActiveRecord/Validations/ClassMethods.html#method-i-validates_uniqueness_of
https://www.redmine.org/projects/redmine/repository/svn/revisions/8041

#6 - 2012-02-02 20:31 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

add_unique_index_in_issue_relations.patch 1013 Bytes 2011-12-01 Etienne Massip
